/************************************************************************************************
** Project:     FSMGenerator
** Module:	FSMGenerator::examples::Cpp
** File:	README
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**             This program is free software; you can redistribute it and/or
**             modify it under the terms of the GNU General Public License as
**             published by the Free Software Foundation; either version 2 of
**             the License, or (at your option) any later version.
**
**             This program is distributed in the hope that it will be useful,
**             but WITHOUT ANY WARRANTY; without even the implied warranty of
**             MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**             GNU General Public License for more details.
**
**             You should have received a copy of the GNU General Public License
**             along with this program; if not, write to the Free Software
**             Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
************************************************************************************************/

#include <iostream>

#include "main_FSMRing.h"
#include "FSMApi.h"
#include "FSMRing.h"

using namespace std;
using namespace FSMApi;

int g_nCounter = 100000000;

int main()
{
	AbstractFSM *pNewFSM = new FSMRing::FSMRing();
	FSM *pFsm = new FSM( *pNewFSM );

    try
    {
      pFsm->Initialize();

	  cout << "Start" << endl;

		for(;--g_nCounter;)
		{
			pFsm->Process( FSMRing::EVENT_input_stay );
		}

		cout << "End" << endl;
	  
      if( pFsm->IsFinal() )
      {
        cout << "Final"  << endl;
      }

      else
      {
        cout << "NonFinal" << endl;
      }

      pFsm->Finalize();
    }
    catch( FSMException& e )
    {
      cout << e.what() << endl;
    }

	delete pFsm;
	delete pNewFSM;

	return 1;
}

void Func00()
{
	//cout << "in Func00" << endl;
}

void Func01()
{
	cout << "in Func01" << endl;
}

void Func02()
{
	cout << "in Func02" << endl;
}

void Func03()
{
	cout << "in Func03" << endl;
}

void Func04()
{
	cout << "in Func04" << endl;
}

void Func05()
{
	cout << "in Func05" << endl;
}

void Func06()
{
	cout << "in Func06" << endl;
}

void Func07()
{
	cout << "in Func07" << endl;
}

void Func08()
{
	cout << "in Func08" << endl;
}

void Func09()
{
	cout << "in Func09" << endl;
}

